﻿#include<iostream>

#include<cstdlib>

using namespace std;



class Queue{ //FIFO First In First Out

    private:
      
	struct node{

	    int info;

	    struct node *next; 
	    struct node *prev; //we also need *prev for deleting from the front of the queue

	};

        node *rear;

        node *front;
	
	int count;

    public:

        Queue() : rear(NULL), front(NULL), count(0) {} // Constructor for the queue
	
	~Queue();

        void enqueue(int data);

        void dequeue();

        void display();
	
	size_t size() const { return count; }
	
	bool empty() const { return count == 0; }

};

void Queue::enqueue(int data){ // add data to the rear (back) of the queue

    node *temp = new node;

    temp->info = data;

    temp->next = NULL;
    temp->prev = NULL;

    if (this->empty()){
	front = temp;
	rear = temp;
	count++;
	return;
    }
    if (this->size() == 1) front->prev = temp;
    temp->next = rear;
    rear->prev = temp;
    rear = temp;
    count++;
}

void Queue::dequeue(){ // remove data from the front of the queue

    node *temp;

    if(this->empty()){

        cout<<"\nQueue is Emtpty\n";

    }else{

        temp = front;

        front = front->prev;

        cout<<"The data Dequeued is "<<temp->info<<endl;

        delete temp;
	count--;

    }

}

void Queue::display(){

    node *p;

    p = front;

    if(empty()){

        cout<<"\nNothing to Display\n";

    }else{

        while(p!=NULL){

            cout<<p->info;

            p = p->prev;

        }
	cout<<endl;
    }

}

Queue::~Queue(){
  
    node* current = front;

    while (current != NULL)
    {
        node* next = current->prev;
        delete current;
        current = next;
    }

    front = NULL;
    rear = NULL;
}

int main(){

    Queue *q = new Queue();
    q->dequeue();
    q->enqueue(1);
    q->enqueue(2);
    q->enqueue(3);
    q->enqueue(4);
    q->enqueue(5);
    q->display();
    q->dequeue();
    q->dequeue();
    q->display();
    q->enqueue(7);
    q->enqueue(8);
    q->display();
    q->dequeue();
    q->dequeue();
    q->dequeue();
    q->dequeue();
    q->dequeue();
    q->display();
    delete q;
    return 0;

}