//#include <cstdlib>
#include <iostream>
#include <string>
using namespace std;

class StackusingList //LIFO Last In First Out
{
     public:
	  StackusingList(int max) : top(NULL), maxnum(max), count(0) {} //constructor for Stack with maxnum number of nodes
	  ~StackusingList();
	  void push(int element);
	  void pop();
	  void print();
	  size_t size() const { return count; }
	  bool empty() const { return count == 0; }
	  
     private:
	  struct node
	  {
	      int data;
	      node* next;
	  };
	  node *top;
	  int count; 
	  int maxnum;
};

void StackusingList::print()
{
   node *temp;
   temp = top;
   if (this->empty()) cout<<"EMPTY STACK"<<endl;
   while(temp!=NULL)
   {
	cout<<temp->data<<endl;
	temp=temp->next;
   }
}

void StackusingList::pop() // remove the top first element from the stack
{
   if(top == NULL)
	    cout<< "nothing to pop"<<endl;
   else
   {
	node * old = top;
	top = top->next;
	count--;
	delete(old);
   }
}

void StackusingList::push(int element) // add (push) a new element to the top of the stack
{
   if(this->size() == maxnum)
	    cout<<"stack is full"<<endl;
   else
   {
	node *newTop = new node;
	if(top == NULL)
	{       
	    newTop->data = element;
	    newTop->next = NULL;
	    top = newTop;
	    count++;
	}
	else
	{
	    newTop->data = element;
	    newTop->next = top;
	    top = newTop;
	    count++;
	}
   }
}

StackusingList::~StackusingList()
{
   node* current = top;

   while (current != NULL)
   {
       node* next = current->next;
       delete current;
       current = next;
   }

   top = NULL;
}

int main(int argc, char** argv) {   
    StackusingList *sl = new StackusingList(5);
    sl->pop();
    sl->push(1);
    sl->push(2);
    sl->push(3);
    sl->print();
    sl->pop();
    sl->print();
    sl->push(4);
    sl->push(5);
    sl->push(6);
    sl->push(7);
    sl->print();
    delete sl;    
    return 0;
}
