﻿// hy150final13.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <sstream>
#include <cctype>
#include <algorithm>

using namespace std;

// helper
int maximum( int a, int b, int c )
{
   int max = ( a < b ) ? b : a;
   return ( max < c ) ? c : max;
}

// 1) (30%)
// Ζητείται ένα πρόγραμμα το οποίο διαβάζει ελεύθερο κείμενο από την κύρια είσοδο.
// Στη συνέχεια τυπώνει τον αριθμό εμφάνισης μόνο των αλφαριθμητικών χαρακτήρων (a-z, A-Z, 0-9) του κείμενου, για κάθε χαρακτήρα ξεχωριστά.

void ask1()
{
	// Βρίσκουμε ποιο στοιχείο του πίνακα ASCII έχει το μεγαλύτερο δεκαδικό index, αν δε το θυμόμαστε
	int max_ascii_idx = maximum('z','Z','9'); 

	// Δημιουργούμε ένα δυναμικό πίνακα που διατηρεί τόσα στοιχεία όσο το μεγαλύτερο index.
	// Καταχρηστικά προς όφελος της απλότητας της λύσης οι περισσότερες θέσεις θα είναι κενές.
	int* occurences = new int[max_ascii_idx + 1];
	
	std::memset(occurences, 0, (max_ascii_idx + 1) * sizeof(int));
	
	char c;

	// std::stringstream ss("abababapf$s^djflsjafopf.......}-09-09-9-***-*/-\n\tiwDFDOFHDPFEIURYI6456231");

	while((c = cin.get()) != EOF) // cin.good()
	{
		// if(('a' <= c && c <= 'z') || 'A' <= c && c <= 'Z' || '0' <= c && c <= '9')
		if(isalnum(c))
		{
			++occurences[c];
		}
	}

	for(int i = 0; i < max_ascii_idx + 1; ++i)
	{
		if(occurences[i] != 0)
		{
			cout << (char)i << ":" << occurences[i] << "\n";
		}
	}

	delete[] occurences;
}


// 3) (25%)
// Ζητείται μια συνάρτηση η οποία να λαμβάνει ένα μονοδιάστατο πίνακα από χαρακτήρες ως είσοδο καθώς και το μήκος του.
// Στη συνέχεια να αποκρίνεται με 0 ή 1, για το εάν το περιεχόμενο του πίνακα αποτελεί καρκινική επιγραφή ή όχι, αντίστοιχα.
// Σημείωση: Καρκινικές επιγραφές ονομάζονται συμμετρικές φράσεις οι οποίες μπορούν να διαβαστούν είτε από την αρχή είτε από το τέλος.
// Παραδείγματα καρκινικών επιγραφών: «ΑΝΝΑ», «ΝΙΨΟΝΑΝΟΜΗΜΑΤΑΜΗΜΟΝΑΝΟΨΙΝ».

// prototypes
int palindrome_2(char str[], int size);
int palindrome_2(char str[], int size);
char* strrev(char* str);

void ask3()
{
	cout << palindrome_1("ABCDEFGH H GF EDC BA", 20) << "\n";
}

// Version 1: Use of char*
int palindrome_1(char str[], int size)
{
	int i = 0;
	int j = size - 1;
	
	char* str_trimmed = new char[size + 1];
	
	// remove spaces
	int t_i = 0;
	for(int i = 0; i < size; ++i)
	{
		if(str[i] != ' ')
		{
			str_trimmed[t_i++] = toupper(str[i]);//σε περίπτωση που έχει μικρά και κεφαλαία
		}
	}
	str_trimmed[t_i] = '\0';

	char* reversed = strrev(str_trimmed);

	cout << str_trimmed << "\n";
	cout << reversed << "\n";

	int res = strcmp(str_trimmed, reversed) == 0 ? 1 : 0;

	delete[] str_trimmed;
	delete[] reversed;

	return res;
}

// Version 2: Use of std::string
int palindrome_2(char str[], int size)
{
	string orig(str);
	
	for(string::iterator it = orig.begin(); it != orig.end();)
	{
		if(*it == ' ')
		{
			it = orig.erase(it);
		}
		else
		{
			++it;
		}
	}
	transform(orig.begin(), orig.end(), orig.begin(), ::toupper);//σε περίπτωση που έχει μικρά και κεφαλαία
	string swapped(orig.rbegin(), orig.rend()); //reverse(swapped.begin(), swapped.end());

	return orig.compare(swapped) == 0 ? 1 : 0;
}

// Version 3
// Αν ξέρουμε από την εκφώνηση ότι ο πίνακας χαρακτήρων δεν περιέχει κενά τότε
// μπορεί να υλοποιηθεί και με 2 μετρητές που διατρέχουν από την αρχή και από το τέλος αντίστοιχα
// τον πίνακα. Αν έχουμε κενά μπορεί να μπερδευτούμε με αυτή τη λύση γιατί θα πρέπει ο μετρητής να αυξάνεται
// όσο υπάροχυν κενά.
char* strrev(char* str)
{
	int len = strlen(str);
	char* rev = new char[len + 1];
	for(int i = len - 1; i >= 0; --i)
	{
		cout << i << ":" << str[i] << "\n";
		rev[len - i - 1] = str[i]; 
	}

	rev[len] = '\0';

	return rev;
}

// (α) (10%)
// Ζητείται κατάλληλη συνάρτηση void printList(struct infoList *root) που θα εκτυπώνει τα δεδομένα της λίστας που ξεκινάει από τον root.  
// Δηλαδή για κάθε κόμβο, θα εκτυπώνει το name, και όλα τα στοιχεία του πίνακα array. 
//
// (β) (15%)
// Ζητείται κατάλληλη συνάρτηση int isEqual(struct infoList *node1, struct info *node2) που θα επιστρέφει 1 αν o κόμβος node1
// περιέχει ακριβώς τα ίδια δεδομένα με τον κόμβο node2, αλλιώς 0. 
//
// (γ) (20%)
// Ζητείται κατάλληλη συνάρτηση int deleteEquals(struct infoList *root) που θα διατρέχει τη λίστα που ξεκινάει από τον root και θα διαγράφει
// (χρήση free) όλους τους κόμβους που έχουν ίσα στοιχεία, αφήνοντας μόνο το πρώτο. Η συνάρτηση θα επιστρέφει πόσους κόμβους έχει διαγράψει.
// Για παράδειγμα αν ο πρώτος κόμβος της λίστας, εμφανίζεται ακριβώς ως δεδομένα και στο τρίτο και στον τέταρτο, θα πρέπει να διαγραφούν οι κόμβοι 3,4.  

// Implementation - slightly different

typedef struct _list* List;

typedef struct _node {
  char* name;
  float* farray;
  int farray_len;
  struct _node *next;
} * Node;

struct _list {
  Node head;
};


// (a)

//helper
void print_float_array(float* farray, int farray_len)
{
	printf("[ ");
	for(int i = 0; i < farray_len; ++i)
	{
		printf("%f ", farray[i]);
	}
	printf("]\n\n");
}

void List_print(List list)
{
	Node ptr;
	if (list == NULL)
		return;
	ptr = list->head;
	printf("\n********** List Nodes **********\n");
	while (ptr != NULL)
	{
		printf("I am node: %s, my next is: %s\n",
			ptr->name,
			ptr->next ? ptr->next->name : "Nobody"
			);
		print_float_array(ptr->farray, ptr->farray_len);
		ptr = ptr->next;
	}
}

// (b)
int List_is_equal(Node node1, Node node2)
{
	if(strcmp(node1->name, node2->name) == 0 && node1->farray_len == node2->farray_len)
	{
		for(int i = 0; i < node1->farray_len; ++i)
		{
			if(node1->farray[i] != node2->farray[i])
			{
				return 0;
			}
		}

		return 1;
	}

	return 0;
}

// (c)
void List_delete_equals(List list)
{
	Node p, q, prev, temp;

	p = q = prev = list->head;
	q = q->next;
	while (p != NULL)
	{
		while (q != NULL && !List_is_equal(q,p))
		{
			prev = q;
			q = q->next;
		}

		if (q == NULL)
		{
			p = p->next;
			if (p != NULL)
			{
				q = p->next;
			}
		}
		else if (List_is_equal(q,p))
		{
			prev->next = q->next;
			temp = q;
			q = q->next;

			delete[] temp->name;
			delete[] temp->farray;
			delete temp;
		}
	}
}

int main(int argc, char* argv[])
{
	system("pause");
	return 0;
}

